//+------------------------------------------------------------------+
//|                                                  SaveSetFile.mqh |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property strict

#import "kernel32.dll"
   int CopyFileW(string,string,int);
   bool DeleteFileW(string);
#import

void SaveSetFile(string aFolderName){

   if(!IsDllsAllowed()){
      Alert("Allow DLL");
   }

   ChartSaveTemplate(ChartID(),(string)ChartID());
   
   string src=TerminalInfoString(TERMINAL_DATA_PATH)+"\\templates\\"+(string)ChartID()+".tpl";
   string dst=TerminalInfoString(TERMINAL_DATA_PATH)+"\\MQL4\\Files\\"+(string)ChartID()+".tpl";
   
   if(CopyFileW(src,dst,0)==1){

   }
   else{
      Print("Failed to copy tpl file");   
   }
   
   if(!DeleteFileW(src)){
      Print("Failed to delete tpl file");
   }
   
   int h=FileOpen((string)ChartID()+".tpl",FILE_READ|FILE_TXT);
   
   if(h!=-1){
      string fc="";
      while(!FileIsEnding(h)){
         string str=FileReadString(h);
         if(StringFind(str,"<expert>")!=-1){
            while(!FileIsEnding(h)){
               str=FileReadString(h);
               if(StringFind(str,"<inputs>")!=-1){
                  while(!FileIsEnding(h)){
                     str=FileReadString(h);
                     if(StringFind(str,"</inputs>")!=-1){
                        break;
                     }
                     else{
                        fc=fc+str+"\n"; 
                     }
                  }   
                  break;
               }
            }
            break;
         }
      }
      FileClose(h);
      string fn=aFolderName;
      if(fn==""){
         fn=MQLInfoString(MQL_PROGRAM_NAME)+"_"+Symbol()+"_"+(string)ChartID();
      }
      string fn2=TimeToString(TimeCurrent(),TIME_SECONDS);
      StringReplace(fn2,":","-");      
      fn2=TimeToString(TimeCurrent(),TIME_DATE)+" "+fn2;
      fn=fn+"\\"+fn2+".set";
      int h2=FileOpen(fn,FILE_WRITE|FILE_TXT);
      if(h2!=-1){
         FileWrite(h2,fc);
         Print("Set file saved");
         FileClose(h2);
      }
      else{
         Print("Failed to open set file");
      }
   }
   else{
      Print("Failed to open tpl file");
   }
   
   FileDelete((string)ChartID()+".tpl");
}
